<!DOCTYPE html>
<%@Language="VBScript"%>
<%
ON ERROR RESUME NEXT
RESPONSE.BUFFER = TRUE
SERVER.SCRIPTTIMEOUT = 1000
installedCOMs = 0 'SETUP INSTALLED COMPONENT COUNTER
onNum = 0					'SETUP TOTAL COMPONENT COUNTER
componentDelimter = vbnewline 'SPLIT THE LOADED COMPONENTS USING THE LINEFEED AS A DELIMTER
categoryFilter = 99 'DEFAULT CATEGORY FILTER (means show all, couldn't use ZERO as it was taken by the first Array entry)
IF ISNUMERIC(REQUEST("categoryFilter")) AND REQUEST("categoryFilter") <> "" THEN categoryFilter = REQUEST("categoryFilter")
statusFilter="installed" 'DEFAULT STATUS FILTER (means show only installed by default)
IF REQUEST("statusFilter") = "all" OR REQUEST("statusFilter") = "installed" OR REQUEST("statusFilter") = "notInstalled" THEN statusFilter = REQUEST("statusFilter")
com = Split(GetTextFromUrl("http://bobmckay.com/asp-component-detection/componentList.txt"), componentDelimter) 'LOAD COMPONENT LIST FROM SOURCE SERVER
categoryList = "Miscellaneous|Email|Browser|Upload|Image|Documents|File Management|Graphs & Charts|Server Management|Users & Security|E-Commerce|Validation|Forms|XML"
cat = Split(categoryList, "|")
%>
<html lang="en">
<head>
<title>ASP Component Detection Script by Bob McKay</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="//netdna.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap.min.css">
<link rel="stylesheet" href="//netdna.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap-theme.min.css">
</head>
<body>
<div class="navbar navbar-inverse navbar-fixed-top" role="navigation">
  <div class="container">
    <div class="navbar-header">
      <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse"><span class="sr-only">Toggle navigation</span><span class="icon-bar"></span><span class="icon-bar"></span><span class="icon-bar"></span></button>
      <a class="navbar-brand" href="http://bobmckay.com/web/classic-asp/classic-asp-component-detection-script/">ASP Component Test by Bob McKay</a>
    </div>
    <div class="navbar-collapse collapse">
			<ul class="nav navbar-nav">
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown">Filter by Status <b class="caret"></b></a>
          <ul class="dropdown-menu">
						<li<%IF statusFilter = "all" THEN RESPONSE.WRITE(" class=""active""")%>><a href="?statusFilter=all&amp;categoryFilter=<%=categoryFilter%>">Show All</a></li>
						<li<%IF statusFilter = "installed" THEN RESPONSE.WRITE(" class=""active""")%>><a href="?statusFilter=installed&amp;categoryFilter=<%=categoryFilter%>">Show Installed</a></li>
						<li<%IF statusFilter = "notInstalled" THEN RESPONSE.WRITE(" class=""active""")%>><a href="?statusFilter=notInstalled&amp;categoryFilter=<%=categoryFilter%>">Show Not Installed</a></li>
          </ul>
        </li>
        <li class="dropdown">
          <a href="#" class="dropdown-toggle" data-toggle="dropdown">Filter by Category <b class="caret"></b></a>
          <ul class="dropdown-menu">
<%
RESPONSE.WRITE("            <li")
IF CSTR(categoryFilter) = "99" THEN RESPONSE.WRITE(" class=""active""")
RESPONSE.WRITE("><a href=""?categoryFilter=99&statusFilter=" & statusFilter & """>Show All</a></li>")
FOR i = 0 to UBound(cat) 
RESPONSE.WRITE("            <li")
IF CSTR(categoryFilter) = CSTR(i) THEN RESPONSE.WRITE(" class=""active""")
RESPONSE.WRITE("><a href=""?categoryFilter=" & i & "&statusFilter=" & statusFilter & """>" & cat(i) & "</a></li>")
NEXT
%>
          </ul>
        </li>
        <li><a href="http://bobmckay.com/web/classic-asp/classic-asp-component-detection-script/">Visit BobMcKay.com</a></li>
      </ul>    </div><!--/.navbar-collapse -->
  </div>
</div>
<div class="jumbotron">
  <div class="container">
    <h1>ASP Component Test</h1>
    <p>This is a simple script to test whether or not common ASP/VBScript Components are installed on a server.</p>
    <p>Use the dropdowns above to filter the results.</p>
    <p>Created by Bob McKay, based heavily on a VBScript class written by James Harris.</p>
    <p><a class="btn btn-primary btn-lg" role="button" title="Go to script page on BobMcKay.com" href="http://bobmckay.com/web/classic-asp-script-detect-installed-asp-components/">Learn more &gt;</a></p>
  </div>
</div>
<div class="container">
<div class="row">
<p>Please wait while testing <%=(UBound(com) + 1)%> components. This may take a few seconds to load.</p>
<% response.flush() %>
<table class="table">
  <tr> 
		<th>#</th>
    <th>Category</th>
    <th>Status</th>
    <th>Com</th>
    <th>Search Google.com</th>
  </tr>
<%
FOR i = 0 to UBound(com)
	comDetails = split(com(i), "|")
	comCreate = comDetails(0)
	comURL = comDetails(1)
	comName = comDetails(2)
	comCat = CInt(comDetails(3))
	comCat2 = CInt(comDetails(4))
	installed = IsObjInstalled(comCreate)
	IF installed <> TRUE THEN installed = FALSE
	onNum = onNum + 1
	
	IF (CSTR(categoryFilter) <> "99" AND CSTR(categoryFilter) = CSTR(comCat)) OR CSTR(categoryFilter) = "99" THEN
		IF statusFilter = "all" OR (statusFilter = "installed" AND installed ) OR (statusFilter = "notInstalled" AND NOT installed) THEN
	
%>
<tr <%IF NOT installed then RESPONSE.WRITE(" class=""danger""")%>>
    <td><%=(onNum)%></td>
    <td><% if categoryFilter = 99 THEN
		RESPONSE.WRITE(cat(comCat))
		ELSE
		RESPONSE.WRITE(cat(categoryFilter))
		END IF
		%></td>
    <td>	<%
		IF NOT installed then 
			RESPONSE.WRITE("<span class=""ninst"">Not Installed</span>")
		ELSE
			installedCOMs = installedComs + 1
			RESPONSE.WRITE("<span class=""inst"">Installed</span>")
		END IF
		%>
    </td>
    <td><% if comURL <> "" then %><a href="<%=comURL%>" target="_blank"><%=comName%></a><% else %><%=comName%><% end if %></td>
    <td><a class="btn btn-success btn-sm" href="https://www.google.co.uk/search?q=<%=SERVER.URLEncode(comName)%>+asp+component" title="Search Google.com for '<%=comName%> ASP Component'">Search Google</a></td>
  </tr>
  <%
		END IF
	END IF
	installed = "" : comCreate = "" : comURL = "" : comName = "" : comCat = "" : comCat2 = ""

response.flush()
NEXT
IF onNum = 0 THEN RESPONSE.WRITE ("<tr><td colspan=""4"">You do not have any components installed for your selections.</td></tr>")
%>
</table>
<h4>You have a total of <b><%=installedCOMs%></b> COMs installed out of <b><%=onNum%></b> checked.</h4>
</div>
</div>
</body>
<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js"></script>
<script src="//netdna.bootstrapcdn.com/bootstrap/3.1.1/js/bootstrap.min.js"></script>
</html>
<%
FUNCTION IsObjInstalled(strClassString)
 IsObjInstalled = FALSE : Err = 0
	 SET testObj = Server.CreateObject(strClassString)
		 IF (0 = Err) THEN IsObjInstalled = TRUE ELSE IsObjInstalled = FALSE
	 SET testObj = NOTHING
END FUNCTION

FUNCTION GetTextFromUrl(url)
  DIM oXMLHTTP
  DIM strStatusTest
  SET oXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP.3.0")
  oXMLHTTP.Open "GET", url, FALSE
  oXMLHTTP.Send
  IF oXMLHTTP.Status = 200 THEN
    GetTextFromUrl = oXMLHTTP.responseText
	ELSE
		GetTextFromUrl = "Error Retrieving Data"
  END IF
END FUNCTION
%>